; ///////////////////////////////////////////////////////////////////////////
; 
;                             PureLZMA DLL INCLUDE
;
; ///////////////////////////////////////////////////////////////////////////
;
; Same PureLZMA_* functions as the eponymous userlibrary (use it's help file),
; but named PureLZMA_DLL_*
;
#UseStatic = #True
;
CompilerIf #UseStatic
  ;
  ; THE STATIC WAY
  ;
  ; Import Functions from library
  ;
  Import "PureLZMA.lib"
    PureLZMA_DLL_SetOptions(Opt_Level, DictSize, lc, lp, pb, fb, NumThreads) As "_PureLZMA_DLL_SetOptions@28" ; Set LZMA compression options
    PureLZMA_DLL_Compress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") As "_PureLZMA_DLL_Compress@12" ; Compress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
    PureLZMA_DLL_UnCompress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") As "_PureLZMA_DLL_UnCompress@12" ; Uncompress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
    PureLZMA_DLL_FreeBuffer(*Buffer) As "_PureLZMA_DLL_FreeBuffer@4" ; Free LZMA output buffer
  EndImport
  ;
  ; or
  ;
CompilerElse
  ;
  ; THE DYNAMIC WAY
  ;
  ; Define prototypes
  ;
  Prototype.l Proto_PureLZMA_DLL_SetOptions(Opt_Level, DictSize, lc, lp, pb, fb, NumThreads) ; Set LZMA compression options
  Prototype.l Proto_PureLZMA_DLL_Compress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") ; Compress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
  Prototype.l Proto_PureLZMA_DLL_UnCompress(*Buffer, *BufferLen.Long, EncryptionKey.s = "") ; Uncompress a buffer with LZMA [Returns *OutputBuffer or error code [<=0]]
  Prototype.l Proto_PureLZMA_DLL_FreeBuffer(*Buffer) ; Free LZMA output buffer
  ;
  ; Get functions
  ;
  PureLZMA = OpenLibrary(#PB_Any, "PureLZMA.DLL")
  If PureLZMA
    PureLZMA_DLL_SetOptions.Proto_PureLZMA_DLL_SetOptions = GetFunction(PureLZMA, "PureLZMA_DLL_SetOptions")
    PureLZMA_DLL_Compress.Proto_PureLZMA_DLL_Compress = GetFunction(PureLZMA, "PureLZMA_DLL_Compress")
    PureLZMA_DLL_UnCompress.Proto_PureLZMA_DLL_UnCompress = GetFunction(PureLZMA, "PureLZMA_DLL_UnCompress")
    PureLZMA_DLL_FreeBuffer.Proto_PureLZMA_DLL_FreeBuffer = GetFunction(PureLZMA, "PureLZMA_DLL_FreeBuffer")
  Else
    End
  EndIf
CompilerEndIf
;
; ///////////////////////////////////////////////////////////////////////////